//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%44327A0A0358.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%44327A0A0358.cm

//## begin module%44327A0A0358.cp preserve=no
//## end module%44327A0A0358.cp

//## Module: XSModExpTree%44327A0A0358; Package specification
//## Subsystem: XSUtil::Parse%3E8C4EAA02A6
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Parse/XSModExpTree.h

#ifndef XSMODEXPTREE_H
#define XSMODEXPTREE_H 1

//## begin module%44327A0A0358.additionalIncludes preserve=no
//## end module%44327A0A0358.additionalIncludes

//## begin module%44327A0A0358.includes preserve=yes
#include <xsTypes.h>
#include <XSUtil/Error/Error.h>
#include <vector>
#include <algorithm>
//## end module%44327A0A0358.includes

//## begin module%44327A0A0358.declarations preserve=no
//## end module%44327A0A0358.declarations

//## begin module%44327A0A0358.additionalDeclarations preserve=yes
template <typename T>
class XSModExpTree;

class ExpTreeNodeType 
{
   public:
      ExpTreeNodeType():pos(-999), parentPos(-1), children() {}
      int pos;
      int parentPos;
      IntegerArray children;
      
};
//## end module%44327A0A0358.additionalDeclarations


//## begin XSModExpTree_Iterator%443289AC0145.preface preserve=yes
//## end XSModExpTree_Iterator%443289AC0145.preface

//## Class: XSModExpTree_Iterator%443289AC0145; Parameterized Class
//	It would really be cleaner to combine the ValCont and Ret
//	Type template parameters into a single Traits class.
//	However, SunWS6.0 seemed to have bizarre and
//	unsystematic compile-time errors when RetType was
//	enclosed in a traits class and used as the return type
//	of a function (which is really its sole purpose).
//## Category: XSUtil::Parse%36939CA6F48B
//## Subsystem: XSUtil::Parse%3E8C4EAA02A6
//## Persistence: Transient
//## Cardinality/Multiplicity: n



template <typename T, typename ValCont, typename RetType>
class XSModExpTree_Iterator 
{
  //## begin XSModExpTree_Iterator%443289AC0145.initialDeclarations preserve=yes
  //## end XSModExpTree_Iterator%443289AC0145.initialDeclarations

  public:
    //## Constructors (generated)
      XSModExpTree_Iterator(const XSModExpTree_Iterator< T,ValCont,RetType > &right);

    //## Destructor (generated)
      ~XSModExpTree_Iterator();

    //## Assignment Operation (generated)
      XSModExpTree_Iterator< T,ValCont,RetType > & operator=(const XSModExpTree_Iterator< T,ValCont,RetType > &right);


    //## Other Operations (specified)
      //## Operation: operator++%443292420102
      XSModExpTree_Iterator<T,ValCont,RetType>& operator ++ ();

      //## Operation: operator++%443296EB009D
      const XSModExpTree_Iterator<T,ValCont,RetType> operator ++ (int );

      //## Operation: operator==%443297AD0313
      bool operator == (const XSModExpTree_Iterator<T,ValCont,RetType>& right) const;

      //## Operation: operator!=%4432A9E30050
      bool operator != (const XSModExpTree_Iterator<T,ValCont,RetType>& right) const;

      //## Operation: operator*%4432C3620196
      RetType& operator * ();

      //## Operation: operator->%4432C61B0352
      RetType* operator -> ();

      //## Operation: childNodes%4436DDF500D7
      void childNodes (IntegerArray& children) const;

      //## Operation: postOrderNext%443A714B021D
      XSModExpTree_Iterator<T,ValCont,RetType>& postOrderNext ();

    // Additional Public Declarations
      //## begin XSModExpTree_Iterator%443289AC0145.public preserve=yes
      //## end XSModExpTree_Iterator%443289AC0145.public

  protected:
    // Additional Protected Declarations
      //## begin XSModExpTree_Iterator%443289AC0145.protected preserve=yes
      //## end XSModExpTree_Iterator%443289AC0145.protected

  private:
    //## Constructors (specified)
      //## Operation: XSModExpTree_Iterator%4432AB52006E
      XSModExpTree_Iterator (const ExpTreeNodeType* nodePointer, const std::vector<ExpTreeNodeType>& nodeArray, ValCont& valueArray, const XSModExpTree<T>* theContainer);


    //## Other Operations (specified)
      //## Operation: nextPreOrder%4432E952032C
      int nextPreOrder (int nodePos) const;

    // Additional Private Declarations
      //## begin XSModExpTree_Iterator%443289AC0145.private preserve=yes
      //## end XSModExpTree_Iterator%443289AC0145.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: nodePointer%44329168038E
      //## begin XSModExpTree_Iterator::nodePointer%44329168038E.attr preserve=no  private: const ExpTreeNodeType* {U} 
      const ExpTreeNodeType* m_nodePointer;
      //## end XSModExpTree_Iterator::nodePointer%44329168038E.attr

      //## Attribute: nodeArray%4432D47E00E8
      //## begin XSModExpTree_Iterator::nodeArray%4432D47E00E8.attr preserve=no  private: const std::vector<ExpTreeNodeType>& {U} 
      const std::vector<ExpTreeNodeType>& m_nodeArray;
      //## end XSModExpTree_Iterator::nodeArray%4432D47E00E8.attr

      //## Attribute: valueArray%4433E419022A
      //## begin XSModExpTree_Iterator::valueArray%4433E419022A.attr preserve=no  private: ValCont& {U} 
      ValCont& m_valueArray;
      //## end XSModExpTree_Iterator::valueArray%4433E419022A.attr

      //## Attribute: theContainer%443574C5031A
      //## begin XSModExpTree_Iterator::theContainer%443574C5031A.attr preserve=no  private: const XSModExpTree<T>* {U} 
      const XSModExpTree<T>* m_theContainer;
      //## end XSModExpTree_Iterator::theContainer%443574C5031A.attr

    // Additional Implementation Declarations
      //## begin XSModExpTree_Iterator%443289AC0145.implementation preserve=yes
       template <typename U>
       friend class XSModExpTree;
      //## end XSModExpTree_Iterator%443289AC0145.implementation
};

//## begin XSModExpTree_Iterator%443289AC0145.postscript preserve=yes
//## end XSModExpTree_Iterator%443289AC0145.postscript

//## begin XSModExpTree%44328BBC002F.preface preserve=yes
//## end XSModExpTree%44328BBC002F.preface

//## Class: XSModExpTree%44328BBC002F; Parameterized Class
//	This is a specialized tree class for containing the
//	relations between XSPEC Expressions and their nested
//	sub-Expressions (or the same relations among Component
//	Group objects).  This does not offer the level of
//	functionality of STL containers (by a long shot).
//
//	Important:  This performs NO internal ordering.  It
//	ASSUMES client will enter values in a POST_ORDER fashion
//	and supply appropriate relational information .  The
//	tree iterators will then perform a PRE-ORDER traversal,
//	but with the begin node defined as the root's first
//	child rather than the root itself (due to the nature of
//	the way Expressions and ComponentGroups are used in
//	XSPEC).
//
//	As with STL, the end iterator does not point to a valid
//	element.  Also like STL, this DOES NOT call delete on
//	values during cleanup if T is a pointer.  The client
//	will need to do this by retrieving the values array.
//## Category: XSUtil::Parse%36939CA6F48B
//## Subsystem: XSUtil::Parse%3E8C4EAA02A6
//## Persistence: Transient
//## Cardinality/Multiplicity: n



template <typename T>
class XSModExpTree 
{
  //## begin XSModExpTree%44328BBC002F.initialDeclarations preserve=yes
  //## end XSModExpTree%44328BBC002F.initialDeclarations

  public:
    //## Class: iterator%44328C8C0270
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef XSModExpTree_Iterator<T,std::vector<T>,T > iterator;

    //## Class: const_iterator%443539230191
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef XSModExpTree_Iterator<T,const std::vector<T>, const T > const_iterator;

    //## Constructors (generated)
      XSModExpTree();

      XSModExpTree(const XSModExpTree< T > &right);

    //## Destructor (generated)
      ~XSModExpTree();

    //## Assignment Operation (generated)
      XSModExpTree< T > & operator=(const XSModExpTree< T > &right);


    //## Other Operations (specified)
      //## Operation: begin%44328E7403E4
      typename XSModExpTree<T>::iterator begin ();

      //## Operation: end%44328F0001CD
      typename XSModExpTree<T>::iterator end ();

      //## Operation: clear%4432C9DD0251
      void clear ();

      //## Operation: insert%4432C9EB000A
      //	This REQUIRES that insertion is done in post-order
      //	fashion, meaning that all nodes specified in the
      //	children array have already been inserted.
      void insert (T entry, const IntegerArray& children);

      //## Operation: begin%443539B6009A
      typename XSModExpTree<T>::const_iterator begin () const;

      //## Operation: end%443539DC0173
      typename XSModExpTree<T>::const_iterator end () const;

      //## Operation: values%4435598C0228
      std::vector<T>& values ();

      //## Operation: size%4435629E0237
      size_t size () const;

      //## Operation: position%443569420053
      int position (const typename XSModExpTree<T>::iterator& it) const;

      //## Operation: position%44356E7A0018
      int position (const typename XSModExpTree<T>::const_iterator& it) const;

      //## Operation: postBegin%443A6F740154
      typename XSModExpTree<T>::iterator postBegin ();

      //## Operation: postBegin%443A6FBF03CC
      typename XSModExpTree<T>::const_iterator postBegin () const;

      //## Operation: insertRoot%443C0E0C0070
      void insertRoot (const IntegerArray& rootChildren);

      //## Operation: getRoot%443C0E460182
      const IntegerArray& getRoot () const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: values%4432C9690141
      const std::vector<T>& values () const;

  public:
    // Additional Public Declarations
      //## begin XSModExpTree%44328BBC002F.public preserve=yes
      //## end XSModExpTree%44328BBC002F.public

  protected:
    // Additional Protected Declarations
      //## begin XSModExpTree%44328BBC002F.protected preserve=yes
      //## end XSModExpTree%44328BBC002F.protected

  private:

    //## Other Operations (specified)
      //## Operation: swap%44366E71022E
      void swap (XSModExpTree<T>& right);

    // Additional Private Declarations
      //## begin XSModExpTree%44328BBC002F.private preserve=yes
      //## end XSModExpTree%44328BBC002F.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: nodes%44328C4100C4
      //## begin XSModExpTree::nodes%44328C4100C4.attr preserve=no  public: std::vector<ExpTreeNodeType> {U} 
      std::vector<ExpTreeNodeType> m_nodes;
      //## end XSModExpTree::nodes%44328C4100C4.attr

      //## begin XSModExpTree::values%4432C9690141.attr preserve=no  public: std::vector<T> {U} 
      std::vector<T> m_values;
      //## end XSModExpTree::values%4432C9690141.attr

    // Additional Implementation Declarations
      //## begin XSModExpTree%44328BBC002F.implementation preserve=yes
      //## end XSModExpTree%44328BBC002F.implementation

};

//## begin XSModExpTree%44328BBC002F.postscript preserve=yes
//## end XSModExpTree%44328BBC002F.postscript

// Parameterized Class XSModExpTree_Iterator 


//## Other Operations (inline)
template <typename T, typename ValCont, typename RetType>
inline bool XSModExpTree_Iterator<T,ValCont,RetType>::operator == (const XSModExpTree_Iterator<T,ValCont,RetType>& right) const
{
  //## begin XSModExpTree_Iterator::operator==%443297AD0313.body preserve=yes
   return m_nodePointer == right.m_nodePointer;
  //## end XSModExpTree_Iterator::operator==%443297AD0313.body
}

template <typename T, typename ValCont, typename RetType>
inline bool XSModExpTree_Iterator<T,ValCont,RetType>::operator != (const XSModExpTree_Iterator<T,ValCont,RetType>& right) const
{
  //## begin XSModExpTree_Iterator::operator!=%4432A9E30050.body preserve=yes
   return m_nodePointer != right.m_nodePointer;
  //## end XSModExpTree_Iterator::operator!=%4432A9E30050.body
}

template <typename T, typename ValCont, typename RetType>
inline RetType& XSModExpTree_Iterator<T,ValCont,RetType>::operator * ()
{
  //## begin XSModExpTree_Iterator::operator*%4432C3620196.body preserve=yes
   if (!m_nodePointer)
      throw RedAlert("Attempting to dereference non-existing XSModExpTree node.");
   return m_valueArray[m_nodePointer->pos];
  //## end XSModExpTree_Iterator::operator*%4432C3620196.body
}

template <typename T, typename ValCont, typename RetType>
inline RetType* XSModExpTree_Iterator<T,ValCont,RetType>::operator -> ()
{
  //## begin XSModExpTree_Iterator::operator->%4432C61B0352.body preserve=yes
   if (!m_nodePointer)
      throw RedAlert("Attempting to dereference non-existing XSModExpTree node.");
   return &m_valueArray[m_nodePointer->pos];
  //## end XSModExpTree_Iterator::operator->%4432C61B0352.body
}

template <typename T, typename ValCont, typename RetType>
inline void XSModExpTree_Iterator<T,ValCont,RetType>::childNodes (IntegerArray& children) const
{
  //## begin XSModExpTree_Iterator::childNodes%4436DDF500D7.body preserve=yes
   children = m_nodePointer->children;
  //## end XSModExpTree_Iterator::childNodes%4436DDF500D7.body
}

// Parameterized Class XSModExpTree 


//## Other Operations (inline)
template <typename T>
inline std::vector<T>& XSModExpTree<T>::values ()
{
  //## begin XSModExpTree::values%4435598C0228.body preserve=yes
   return m_values;
  //## end XSModExpTree::values%4435598C0228.body
}

template <typename T>
inline size_t XSModExpTree<T>::size () const
{
  //## begin XSModExpTree::size%4435629E0237.body preserve=yes
   return m_values.size();
  //## end XSModExpTree::size%4435629E0237.body
}

template <typename T>
inline int XSModExpTree<T>::position (const typename XSModExpTree<T>::iterator& it) const
{
  //## begin XSModExpTree::position%443569420053.body preserve=yes
   int nodePos = it.m_nodePointer->pos;
   if (nodePos < 0 || nodePos >= (int)m_values.size())
      throw RedAlert("Invalid node pointer accessed in ExpTree position function.");
   return nodePos;
  //## end XSModExpTree::position%443569420053.body
}

template <typename T>
inline int XSModExpTree<T>::position (const typename XSModExpTree<T>::const_iterator& it) const
{
  //## begin XSModExpTree::position%44356E7A0018.body preserve=yes
   int nodePos = it.m_nodePointer->pos;
   if (nodePos < 0 || nodePos >= (int)m_values.size())
      throw RedAlert("Invalid node pointer accessed in ExpTree position function.");
   return nodePos;
  //## end XSModExpTree::position%44356E7A0018.body
}

//## Get and Set Operations for Class Attributes (inline)

template <typename T>
inline const std::vector<T>& XSModExpTree<T>::values () const
{
  //## begin XSModExpTree::values%4432C9690141.get preserve=no
  return m_values;
  //## end XSModExpTree::values%4432C9690141.get
}

// Parameterized Class XSModExpTree_Iterator 

template <typename T, typename ValCont, typename RetType>
XSModExpTree_Iterator<T,ValCont,RetType>::XSModExpTree_Iterator(const XSModExpTree_Iterator<T,ValCont,RetType> &right)
  //## begin XSModExpTree_Iterator::XSModExpTree_Iterator%443289AC0145_copy.hasinit preserve=yes
  :m_nodePointer(right.m_nodePointer), // shallow copies, non-owning
   m_nodeArray(right.m_nodeArray),
   m_valueArray(right.m_valueArray),
   m_theContainer(right.m_theContainer)
  //## end XSModExpTree_Iterator::XSModExpTree_Iterator%443289AC0145_copy.hasinit
  //## begin XSModExpTree_Iterator::XSModExpTree_Iterator%443289AC0145_copy.initialization preserve=yes
  //## end XSModExpTree_Iterator::XSModExpTree_Iterator%443289AC0145_copy.initialization
{
  //## begin XSModExpTree_Iterator::XSModExpTree_Iterator%443289AC0145_copy.body preserve=yes
  //## end XSModExpTree_Iterator::XSModExpTree_Iterator%443289AC0145_copy.body
}

template <typename T, typename ValCont, typename RetType>
XSModExpTree_Iterator<T,ValCont,RetType>::XSModExpTree_Iterator (const ExpTreeNodeType* nodePointer, const std::vector<ExpTreeNodeType>& nodeArray, ValCont& valueArray, const XSModExpTree<T>* theContainer)
  //## begin XSModExpTree_Iterator::XSModExpTree_Iterator%4432AB52006E.hasinit preserve=yes
   :m_nodePointer(nodePointer),
    m_nodeArray(nodeArray),
    m_valueArray(valueArray),
    m_theContainer(theContainer)
  //## end XSModExpTree_Iterator::XSModExpTree_Iterator%4432AB52006E.hasinit
  //## begin XSModExpTree_Iterator::XSModExpTree_Iterator%4432AB52006E.initialization preserve=yes
  //## end XSModExpTree_Iterator::XSModExpTree_Iterator%4432AB52006E.initialization
{
  //## begin XSModExpTree_Iterator::XSModExpTree_Iterator%4432AB52006E.body preserve=yes
  //## end XSModExpTree_Iterator::XSModExpTree_Iterator%4432AB52006E.body
}


template <typename T, typename ValCont, typename RetType>
XSModExpTree_Iterator<T,ValCont,RetType>::~XSModExpTree_Iterator()
{
  //## begin XSModExpTree_Iterator::~XSModExpTree_Iterator%443289AC0145_dest.body preserve=yes
  //## end XSModExpTree_Iterator::~XSModExpTree_Iterator%443289AC0145_dest.body
}


template <typename T, typename ValCont, typename RetType>
XSModExpTree_Iterator<T,ValCont,RetType> & XSModExpTree_Iterator<T,ValCont,RetType>::operator=(const XSModExpTree_Iterator<T,ValCont,RetType> &right)
{
  //## begin XSModExpTree_Iterator::operator=%443289AC0145_assign.body preserve=yes
   if (m_theContainer != right.m_theContainer)
      throw RedAlert("Invalid attempt to assign iterator of one XSModExpTree to another.");
   m_nodePointer = right.m_nodePointer;
   return *this;
  //## end XSModExpTree_Iterator::operator=%443289AC0145_assign.body
}



//## Other Operations (implementation)
template <typename T, typename ValCont, typename RetType>
XSModExpTree_Iterator<T,ValCont,RetType>& XSModExpTree_Iterator<T,ValCont,RetType>::operator ++ ()
{
  //## begin XSModExpTree_Iterator::operator++%443292420102.body preserve=yes
   // Pre-increment.  If m_nodePointer = 0, assume we are at the end and
   // do nothing.
   if (m_nodePointer)
   {
      // Let's not assume anywhere that &a[n] == &a[0]+n since this 
      // wasn't truly in the '98 standard.
      int nextPos = nextPreOrder(m_nodePointer->pos);
      if (nextPos == (int)m_nodeArray.size()-1)
      {
         // This is the root node, which we'll use for the end.
         m_nodePointer = 0;
      }
      else
         m_nodePointer = &m_nodeArray[nextPos];
   }
   return *this;
  //## end XSModExpTree_Iterator::operator++%443292420102.body
}

template <typename T, typename ValCont, typename RetType>
const XSModExpTree_Iterator<T,ValCont,RetType> XSModExpTree_Iterator<T,ValCont,RetType>::operator ++ (int )
{
  //## begin XSModExpTree_Iterator::operator++%443296EB009D.body preserve=yes
   XSModExpTree_Iterator<T, ValCont, RetType> oldNode(*this);
   ++(*this);
   return oldNode;
  //## end XSModExpTree_Iterator::operator++%443296EB009D.body
}

template <typename T, typename ValCont, typename RetType>
int XSModExpTree_Iterator<T,ValCont,RetType>::nextPreOrder (int nodePos) const
{
  //## begin XSModExpTree_Iterator::nextPreOrder%4432E952032C.body preserve=yes
   // This is a recursive function.
   const ExpTreeNodeType& testNode = m_nodeArray[nodePos];
   int nChildren = (int)testNode.children.size();
   int currPos = m_nodePointer->pos;
   int nextPos = 0;
   if (nChildren)
   {
      if (currPos == testNode.pos)
         // Simple case, just grab the node's first child.
         nextPos = testNode.children[0];
      else 
      {
         // It has been kicked back up here from a child.  Therefore
         // find whose subtree this is coming from, indicated by first
         // child with pos >= currPos (ASSUMING insertions were post-order).
         int currSubTree = -1;
         for (int i=0; i<nChildren; ++i)
         {
            if (testNode.children[i] >= currPos)
            {
               currSubTree = i;
               break;
            }
         }
         if (currSubTree == -1)
         {
            throw RedAlert("ModExpTree structural relation error.");
         }
         else if (currSubTree == nChildren-1)
         {
            // Pass back up to parent, or if we're at root, simply return
            // the root node position.
            if (testNode.parentPos >= 0)
               nextPos = nextPreOrder(testNode.parentPos);
            else
               nextPos = m_nodeArray.size() - 1;
         }
         else
         {
            // Start on next subtree
            nextPos = testNode.children[currSubTree+1];
         }         
      }
   }
   else
   {
      // Pass back up to parent.  Don't need to check if this is root
      // node, since root will always have at least 1 child and can't
      // get in here.
      nextPos = nextPreOrder(testNode.parentPos);
   }
   return nextPos;             
  //## end XSModExpTree_Iterator::nextPreOrder%4432E952032C.body
}

template <typename T, typename ValCont, typename RetType>
XSModExpTree_Iterator<T,ValCont,RetType>& XSModExpTree_Iterator<T,ValCont,RetType>::postOrderNext ()
{
  //## begin XSModExpTree_Iterator::postOrderNext%443A714B021D.body preserve=yes
   if (m_nodePointer)
   {
      int currPos = m_nodePointer->pos;
      if (currPos >= (int)m_nodeArray.size() - 2)
      {
         // Next is the root node, which we'll use for the end.
         m_nodePointer = 0;
      }
      else
         m_nodePointer = &m_nodeArray[currPos+1];
   }
   return *this;
  //## end XSModExpTree_Iterator::postOrderNext%443A714B021D.body
}

// Additional Declarations
  //## begin XSModExpTree_Iterator%443289AC0145.declarations preserve=yes
  //## end XSModExpTree_Iterator%443289AC0145.declarations

// Parameterized Class XSModExpTree 

template <typename T>
XSModExpTree<T>::XSModExpTree()
  //## begin XSModExpTree::XSModExpTree%44328BBC002F_const.hasinit preserve=no
  //## end XSModExpTree::XSModExpTree%44328BBC002F_const.hasinit
  //## begin XSModExpTree::XSModExpTree%44328BBC002F_const.initialization preserve=yes
  //## end XSModExpTree::XSModExpTree%44328BBC002F_const.initialization
{
  //## begin XSModExpTree::XSModExpTree%44328BBC002F_const.body preserve=yes
  //## end XSModExpTree::XSModExpTree%44328BBC002F_const.body
}

template <typename T>
XSModExpTree<T>::XSModExpTree(const XSModExpTree<T> &right)
  //## begin XSModExpTree::XSModExpTree%44328BBC002F_copy.hasinit preserve=yes
  : m_nodes(right.m_nodes),
    m_values(right.m_values)
  //## end XSModExpTree::XSModExpTree%44328BBC002F_copy.hasinit
  //## begin XSModExpTree::XSModExpTree%44328BBC002F_copy.initialization preserve=yes
  //## end XSModExpTree::XSModExpTree%44328BBC002F_copy.initialization
{
  //## begin XSModExpTree::XSModExpTree%44328BBC002F_copy.body preserve=yes
  //## end XSModExpTree::XSModExpTree%44328BBC002F_copy.body
}


template <typename T>
XSModExpTree<T>::~XSModExpTree()
{
  //## begin XSModExpTree::~XSModExpTree%44328BBC002F_dest.body preserve=yes
  //## end XSModExpTree::~XSModExpTree%44328BBC002F_dest.body
}


template <typename T>
XSModExpTree<T> & XSModExpTree<T>::operator=(const XSModExpTree<T> &right)
{
  //## begin XSModExpTree::operator=%44328BBC002F_assign.body preserve=yes
   if (this != &right)
   {
      XSModExpTree<T> tmp(right);
      swap(tmp);
   }
   return *this;
  //## end XSModExpTree::operator=%44328BBC002F_assign.body
}



//## Other Operations (implementation)
template <typename T>
typename XSModExpTree<T>::iterator XSModExpTree<T>::begin ()
{
  //## begin XSModExpTree::begin%44328E7403E4.body preserve=yes
   // Not true pre-order since begin is not defined as the root,
   // but the root's first child.  The root will be treated as
   // the end.
   ExpTreeNodeType* beginNode = 0;
   if (m_nodes.size() > 1)
   {
      // We have a root, and root has a child.
      const ExpTreeNodeType& root = m_nodes[m_nodes.size()-1];
      beginNode = &m_nodes[root.children[0]];
   }
   return iterator(beginNode, m_nodes, m_values, this);
  //## end XSModExpTree::begin%44328E7403E4.body
}

template <typename T>
typename XSModExpTree<T>::iterator XSModExpTree<T>::end ()
{
  //## begin XSModExpTree::end%44328F0001CD.body preserve=yes
   ExpTreeNodeType* endNode = 0;
   return iterator(endNode, m_nodes, m_values, this);
  //## end XSModExpTree::end%44328F0001CD.body
}

template <typename T>
void XSModExpTree<T>::clear ()
{
  //## begin XSModExpTree::clear%4432C9DD0251.body preserve=yes
   m_values.clear();
   m_nodes.clear();
  //## end XSModExpTree::clear%4432C9DD0251.body
}

template <typename T>
void XSModExpTree<T>::insert (T entry, const IntegerArray& children)
{
  //## begin XSModExpTree::insert%4432C9EB000A.body preserve=yes
   m_values.push_back(entry);
   ExpTreeNodeType newNode;
   newNode.pos = static_cast<int>(m_values.size()-1);
   // parentPos will be set when this node's parent is
   // inserted into the tree.
   newNode.parentPos = -1;
   newNode.children = children;
   m_nodes.push_back(newNode);
   for (size_t i=0; i<children.size(); ++i)
   {
      m_nodes[children[i]].parentPos = newNode.pos;
   }
  //## end XSModExpTree::insert%4432C9EB000A.body
}

template <typename T>
typename XSModExpTree<T>::const_iterator XSModExpTree<T>::begin () const
{
  //## begin XSModExpTree::begin%443539B6009A.body preserve=yes
   const ExpTreeNodeType* beginNode = 0;
   if (m_nodes.size() > 1)
   {
      // We have a root, and root has a child.
      const ExpTreeNodeType& root = m_nodes[m_nodes.size()-1];
      beginNode = &m_nodes[root.children[0]];
   }
   return const_iterator(beginNode, m_nodes, m_values, this);
  //## end XSModExpTree::begin%443539B6009A.body
}

template <typename T>
typename XSModExpTree<T>::const_iterator XSModExpTree<T>::end () const
{
  //## begin XSModExpTree::end%443539DC0173.body preserve=yes
   const ExpTreeNodeType* endNode = 0;
   return const_iterator(endNode, m_nodes, m_values, this);
  //## end XSModExpTree::end%443539DC0173.body
}

template <typename T>
void XSModExpTree<T>::swap (XSModExpTree<T>& right)
{
  //## begin XSModExpTree::swap%44366E71022E.body preserve=yes
   std::swap(m_nodes, right.m_nodes);
   std::swap(m_values, right.m_values);
  //## end XSModExpTree::swap%44366E71022E.body
}

template <typename T>
typename XSModExpTree<T>::iterator XSModExpTree<T>::postBegin ()
{
  //## begin XSModExpTree::postBegin%443A6F740154.body preserve=yes
   ExpTreeNodeType* beginNode = 0;
   if (m_nodes.size() > 1)
   {
      // We have a root, and root has a child.
      beginNode = &m_nodes[0];
   }
   return iterator(beginNode, m_nodes, m_values, this);
  //## end XSModExpTree::postBegin%443A6F740154.body
}

template <typename T>
typename XSModExpTree<T>::const_iterator XSModExpTree<T>::postBegin () const
{
  //## begin XSModExpTree::postBegin%443A6FBF03CC.body preserve=yes
   const ExpTreeNodeType* beginNode = 0;
   if (m_nodes.size() > 1)
   {
      // We have a root, and root has a child.
      beginNode = &m_nodes[0];
   }
   return const_iterator(beginNode, m_nodes, m_values, this);
  //## end XSModExpTree::postBegin%443A6FBF03CC.body
}

template <typename T>
void XSModExpTree<T>::insertRoot (const IntegerArray& rootChildren)
{
  //## begin XSModExpTree::insertRoot%443C0E0C0070.body preserve=yes
   // Root must be inserted AFTER all other nodes.  This will
   // always make m_nodes.size() == m_values.size()+1 in a well
   // constructed tree.
   if (m_nodes.size() && m_nodes.size() == m_values.size())
   {
      ExpTreeNodeType newNode;
      newNode.pos = static_cast<int>(m_nodes.size());
      // parentPos will be set when this node's parent is
      // inserted into the tree.
      newNode.parentPos = -1;
      newNode.children = rootChildren;
      m_nodes.push_back(newNode);
      for (size_t i=0; i<rootChildren.size(); ++i)
      {
         m_nodes[rootChildren[i]].parentPos = newNode.pos;
      }
   }
   else
   {
      throw RedAlert("Improper root insertion attempt in ModExpTree.");
   }
  //## end XSModExpTree::insertRoot%443C0E0C0070.body
}

template <typename T>
const IntegerArray& XSModExpTree<T>::getRoot () const
{
  //## begin XSModExpTree::getRoot%443C0E460182.body preserve=yes
   if (!m_nodes.size())
   {
      throw RedAlert("Attempting to get root node of empty ModExpTree.");
   }
   return m_nodes[m_nodes.size()-1].children;
  //## end XSModExpTree::getRoot%443C0E460182.body
}

// Additional Declarations
  //## begin XSModExpTree%44328BBC002F.declarations preserve=yes
  //## end XSModExpTree%44328BBC002F.declarations

//## begin module%44327A0A0358.epilog preserve=yes
//## end module%44327A0A0358.epilog


#endif
